# IPyDrawio

> Interactive diagram documents and [widgets] in [JupyterLab], powered by [drawio].

[drawio]: https://github.com/jgraph/drawio
[jupyterlab]: https://github.com/jupyterlab/jupyterlab
[widgets]: https://github.com/jupyter-widgets/ipywidgets

---

## Get Started

Install `ipydrawio` (and optionally `ipydrawio-export`) with `pip`, `mamba`, or `conda`:

```bash
pip install ipydrawio[all]
```

or...

```bash
mamba install -c conda-forge ipydrawio  # ipydrawio-export
```

or...

```bash
conda install -c conda-forge ipydrawio  # ipydrawio-export
```

Start JupyterLab and [start making diagrams](./diagrams/index.md)!

---

## Try it Now

```{warning}
The in-browser demo has some <strong>pointy edges</strong>...
<ul>
  <li>
    <code>jupyterlite</code> is <em>beta</em> software, and evolving quickly
  </li>
  <li>
    <strong>Don't</strong> use the demo site for important work
  </li>
</ul>
```

Click the _Try IPyDrawio Now_ button to launch a new browser tab running IPyDrawio in
JupyterLite. It contains all of the example _Diagrams_ from this documentation site, and
some notebooks that show what's posssible.

---

## Features

[![What is IPyDrawio?][poster]][poster]

[poster]: ./Poster.dio.svg

## More Screenshots and Examples

> these are editable SVG files made with IPyDrawio, and can be found in the demo.

### What can you draw with IPyDrawio

[![What can you draw with IPyDrawio?][what-can-you-draw]][what-can-you-draw]

[what-can-you-draw]: ./_static/what-can-you-draw.dio.svg

---

## Learn More

```{toctree}
:maxdepth: 2
diagrams/index
tutorials/index
about/index
api/index
about/contributing
```

<!--
# Copyright 2023 ipydrawio contributors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
-->
